<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransformaDocumentoVendaResponse StructType
 * @subpackage Structs
 */
class TransformaDocumentoVendaResponse extends AbstractStructBase
{
    /**
     * The TransformaDocumentoVendaResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $TransformaDocumentoVendaResult;
    /**
     * The documentoGerado
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabecDocERP
     */
    public $documentoGerado;
    /**
     * The mensagem
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensagem;
    /**
     * The sucesso
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $sucesso;
    /**
     * Constructor method for TransformaDocumentoVendaResponse
     * @uses TransformaDocumentoVendaResponse::setTransformaDocumentoVendaResult()
     * @uses TransformaDocumentoVendaResponse::setDocumentoGerado()
     * @uses TransformaDocumentoVendaResponse::setMensagem()
     * @uses TransformaDocumentoVendaResponse::setSucesso()
     * @param bool $transformaDocumentoVendaResult
     * @param \StructType\CabecDocERP $documentoGerado
     * @param string $mensagem
     * @param bool $sucesso
     */
    public function __construct($transformaDocumentoVendaResult = null, \StructType\CabecDocERP $documentoGerado = null, $mensagem = null, $sucesso = null)
    {
        $this
            ->setTransformaDocumentoVendaResult($transformaDocumentoVendaResult)
            ->setDocumentoGerado($documentoGerado)
            ->setMensagem($mensagem)
            ->setSucesso($sucesso);
    }
    /**
     * Get TransformaDocumentoVendaResult value
     * @return bool|null
     */
    public function getTransformaDocumentoVendaResult()
    {
        return $this->TransformaDocumentoVendaResult;
    }
    /**
     * Set TransformaDocumentoVendaResult value
     * @param bool $transformaDocumentoVendaResult
     * @return \StructType\TransformaDocumentoVendaResponse
     */
    public function setTransformaDocumentoVendaResult($transformaDocumentoVendaResult = null)
    {
        // validation for constraint: boolean
        if (!is_null($transformaDocumentoVendaResult) && !is_bool($transformaDocumentoVendaResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($transformaDocumentoVendaResult)), __LINE__);
        }
        $this->TransformaDocumentoVendaResult = $transformaDocumentoVendaResult;
        return $this;
    }
    /**
     * Get documentoGerado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabecDocERP|null
     */
    public function getDocumentoGerado()
    {
        return isset($this->documentoGerado) ? $this->documentoGerado : null;
    }
    /**
     * Set documentoGerado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CabecDocERP $documentoGerado
     * @return \StructType\TransformaDocumentoVendaResponse
     */
    public function setDocumentoGerado(\StructType\CabecDocERP $documentoGerado = null)
    {
        if (is_null($documentoGerado) || (is_array($documentoGerado) && empty($documentoGerado))) {
            unset($this->documentoGerado);
        } else {
            $this->documentoGerado = $documentoGerado;
        }
        return $this;
    }
    /**
     * Get mensagem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensagem()
    {
        return isset($this->mensagem) ? $this->mensagem : null;
    }
    /**
     * Set mensagem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensagem
     * @return \StructType\TransformaDocumentoVendaResponse
     */
    public function setMensagem($mensagem = null)
    {
        // validation for constraint: string
        if (!is_null($mensagem) && !is_string($mensagem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensagem)), __LINE__);
        }
        if (is_null($mensagem) || (is_array($mensagem) && empty($mensagem))) {
            unset($this->mensagem);
        } else {
            $this->mensagem = $mensagem;
        }
        return $this;
    }
    /**
     * Get sucesso value
     * @return bool|null
     */
    public function getSucesso()
    {
        return $this->sucesso;
    }
    /**
     * Set sucesso value
     * @param bool $sucesso
     * @return \StructType\TransformaDocumentoVendaResponse
     */
    public function setSucesso($sucesso = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucesso) && !is_bool($sucesso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sucesso)), __LINE__);
        }
        $this->sucesso = $sucesso;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TransformaDocumentoVendaResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
